Package commonj.sdo.helper

# Interface XSDHelper

public interface XSDHelper
Provides access to additional information when the Type or Property is defined by an XML Schema (XSD). Methods return null/false otherwise or if the information is unavailable. Defines Types from an XSD.

## Field Summary

Fields
Modifier and Type
Field
Description
`static final XSDHelper`
`INSTANCE`
The default XSDHelper.

## Method Summary

Modifier and Type
Method
Description
`List`
`define(InputStream xsdInputStream, String schemaLocation)`
Define XML Schema as Types.
`List`
`define(Reader xsdReader, String schemaLocation)`
Define XML Schema as Types.
`List`
`define(String xsd)`
Define the XML Schema as Types.
`String`
`generate(List types)`
Generate an XML Schema Declaration (XSD) from Types.
`String`
`generate(List types, Map namespaceToSchemaLocation)`
Generate an XML Schema Declaration (XSD) from Types.
`String`
`getAppinfo(Property property, String source)`
Return the content of the appinfo declared for this Property and source.
`String`
`getAppinfo(Type type, String source)`
Return the appinfo declared for this Type and source.
`Property`
`getGlobalProperty(String uri, String propertyName, boolean isElement)`
Returns the Property defined by the named global element or attribute in the targetNamespace uri, or null if not found.
`String`
`getLocalName(Property property)`
Returns the local name as declared in the XSD.
`String`
`getLocalName(Type type)`
Returns the local name as declared in the XSD.
`String`
`getNamespaceURI(Property property)`
Returns the namespace URI as declared in the XSD.
`boolean`
`isAttribute(Property property)`
Returns true if the property is declared as an attribute in the XSD.
`boolean`
`isElement(Property property)`
Returns true if the property is declared as an element in the XSD.
`boolean`
`isMixed(Type type)`
Returns true if the Type is declared to contain mixed content.
`boolean`
`isXSD(Type type)`
Indicates if this helper contains XSD information for the specified type.

## Field Details

### INSTANCE

static final XSDHelper INSTANCE
The default XSDHelper.

## Method Details

### getLocalName

String getLocalName(Type type)
Returns the local name as declared in the XSD.

Parameters:
  `type` - to return local name for.
Returns:
  the local name as declared in the XSD.

### getLocalName

String getLocalName(Property property)
Returns the local name as declared in the XSD.

Parameters:
  `property` - to return local name for.
Returns:
  the local name as declared in the XSD.

### getNamespaceURI

String getNamespaceURI(Property property)
Returns the namespace URI as declared in the XSD.

Parameters:
  `property` - to return namespace URI for.
Returns:
  the namespace URI as declared in the XSD.

### isAttribute

boolean isAttribute(Property property)
Returns true if the property is declared as an attribute in the XSD. Returns false if not known or for advanced cases. It is possible for both isAttribute and isElement to return false but they will not both return true.

Parameters:
  `property` - to identify if an attribute.
Returns:
  true if the property is declared as an attribute in the XSD.

### isElement

boolean isElement(Property property)
Returns true if the property is declared as an element in the XSD. Returns false if not known or for advanced cases. It is possible for both isAttribute and isElement to return false but they will not both return true.

Parameters:
  `property` - to identify if an element.
Returns:
  true if the property is declared as an element in the XSD.

### isMixed

boolean isMixed(Type type)
Returns true if the Type is declared to contain mixed content. A DataObject's mixed content values are typically accessed via a Sequence.

Parameters:
  `type` - to identify if mixed content.
Returns:
  true if the Type is declared to contain mixed content.

### isXSD

boolean isXSD(Type type)
Indicates if this helper contains XSD information for the specified type.

Parameters:
  `type` - the type.
Returns:
  true if this helper contains XSD information for the specified type.

### getGlobalProperty

Property getGlobalProperty(String uri, String propertyName, boolean isElement)
Returns the Property defined by the named global element or attribute in the targetNamespace uri, or null if not found.

Parameters:
  `uri` - The uri of the targetNamespace.
  `propertyName` - The name of the global property.
  `isElement` - is true for global elements, false for global attributes.
Returns:
  the Property defined by the named global element or attribute in the targetNamespace uri, or null if not found.

### getAppinfo

String getAppinfo(Type type, String source)
Return the appinfo declared for this Type and source. The appinfo start and end tags and content are returned. The xml namespace context is preserved in the appinfo element. If more than one appinfo with the same source is declared on the same Type their contents are concatenated.

Parameters:
  `type` - the type with the appinfo declaration
  `source` - the source of the appinfo declaration.
Returns:
  the appinfo declared for this Type and source.

### getAppinfo

String getAppinfo(Property property, String source)
Return the content of the appinfo declared for this Property and source. If the property is defined by ref= the appinfo of the referenced element or attribute is included. The appinfo start and end tags and content are returned. The xml namespace context is preserved in the appinfo element. If more than one appinfo with the same source is declared on the same Type their contents are concatenated.

Parameters:
  `property` - the Property with the appinfo declaration
  `source` - the source of the appinfo declaration.
Returns:
  the appinfo declared for this Property and source.

### define

List define(String xsd)
Define the XML Schema as Types. The Types are available through TypeHelper and DataGraph getType() methods. Same as define(new StringReader(xsd), null)

Parameters:
  `xsd` - the XML Schema.
Returns:
  the defined Types.
Throws:
  `IllegalArgumentException` - if the Types could not be defined.

### define

List define(Reader xsdReader, String schemaLocation)
Define XML Schema as Types. The Types are available through TypeHelper and DataGraph getType() methods.

Parameters:
  `xsdReader` - reader to an XML Schema.
  `schemaLocation` - the URI of the location of the schema, used for processing relative imports and includes. May be null if not used.
Returns:
  the defined Types.
Throws:
  `IllegalArgumentException` - if the Types could not be defined.

### define

List define(InputStream xsdInputStream, String schemaLocation)
Define XML Schema as Types. The Types are available through TypeHelper and DataGraph getType() methods.

Parameters:
  `xsdInputStream` - input stream to an XML Schema.
  `schemaLocation` - the URI of the location of the schema, used for processing relative imports and includes. May be null if not used.
Returns:
  the defined Types.
Throws:
  `IllegalArgumentException` - if the Types could not be defined.

### generate

String generate(List types)
Generate an XML Schema Declaration (XSD) from Types. Same as generate(types, null);

Parameters:
  `types` - a List containing the Types
Returns:
  a String containing the generated XSD.
Throws:
  `IllegalArgumentException` - if the XSD could not be generated.

### generate

String generate(List types, Map namespaceToSchemaLocation)
Generate an XML Schema Declaration (XSD) from Types. Round trip from SDO to XSD to SDO is supported. Round trip from XSD to SDO to XSD is not supported. Use the original schema if one exists instead of generating a new one, as the generated XSD validates a different set of documents than the original XSD. Generating an XSD does not affect the XSDHelper or the Types. The Types must all have the same URI. The result is a String containing the generated XSD. All Types referenced with the same URI will be generated in the XSD and the list will be expanded to include all types generated. Any Types referenced with other URIs will cause imports to be produced as appropriate. Imports will include a schemaLocation if a Map is provided with an entry of the form key=import target namespace, value=schemaLocation

Parameters:
  `types` - a List containing the Types
  `namespaceToSchemaLocation` - map of target namespace to schema locations or null
Returns:
  a String containing the generated XSD.
Throws:
  `IllegalArgumentException` - if the XSD could not be generated.